Skip site navigation (1)Skip section navigation (2)
Date:      Mon, 22 Feb 2010 07:50:17 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-projects@freebsd.org
Subject:   svn commit: r204194 - projects/stress2/misc
Message-ID:  <201002220750.o1M7oHfT080330@svn.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Mon Feb 22 07:50:17 2010
New Revision: 204194
URL: http://svn.freebsd.org/changeset/base/204194

Log:
  Test overcommit of the file system capacity.

Added:
  projects/stress2/misc/mmap4.sh   (contents, props changed)

Added: projects/stress2/misc/mmap4.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ projects/stress2/misc/mmap4.sh	Mon Feb 22 07:50:17 2010	(r204194)
@@ -0,0 +1,118 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2010 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test overcommit of the file system capacity
+# Causes panic: 1 vncache entries remaining
+
+# Scanario by kib@
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+here=`pwd`
+cd /tmp
+sed '1,/^EOF/d' < $here/$0 > mmap4.c
+cc -o mmap4 -Wall -O2 mmap4.c
+rm -f mmap4.c
+
+mount | grep -q "$mntpoint" && umount $mntpoint
+mdconfig -l | grep -q $mdstart &&  mdconfig -d -u $mdstart
+
+mdconfig -a -t swap -s 40m -u $mdstart
+bsdlabel -w md${mdstart} auto
+
+newfs -U md${mdstart}${part} > /dev/null
+mount /dev/md${mdstart}${part} $mntpoint
+
+/tmp/mmap4 /$mntpoint/file
+ls -lh $mntpoint
+df -h
+
+cd $here
+rm -f /tmp/mmap4
+
+while mount | grep -q $mntpoint; do
+	sync;sync;sync
+	sleep 1
+	umount $mntpoint
+done
+
+mdconfig -d -u $mdstart
+exit 0
+EOF
+#include <sys/types.h>
+#include <err.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <sys/mman.h>
+#include <sys/param.h>
+#include <string.h>
+#include <unistd.h>
+#include <errno.h>
+
+#define STARTADDR 0x0U
+#define ADRSPACE  0x06400000U /* 100 Mb */
+
+int
+main(int argc, char **argv)
+{
+	int fd, ps;
+	void *p;
+	size_t len;
+	char *c, *path;
+
+	p = (void *)STARTADDR;
+	len = ADRSPACE;
+
+	path = argv[1];
+	if ((fd = open(path, O_CREAT | O_TRUNC | O_RDWR, 0622)) == -1)
+		err(1,"open()");
+	if (ftruncate(fd, len) == -1)
+		err(1, "ftruncate");
+	if ((p = mmap(p, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0)) ==
+			MAP_FAILED) {
+		if (errno == ENOMEM)
+			return (1);
+		err(1, "mmap(1)");
+	}
+
+	c = p;
+	ps = getpagesize();
+	for (c = p; (void *)c < p + len; c += ps) {
+		*c = 1;
+	}
+
+	close(fd);
+
+	return (0);
+}



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201002220750.o1M7oHfT080330>